<script>
  import Router, { push, replace } from 'svelte-spa-router'
  import { routes } from './routes'
  import { get } from './utils/request'
  import { authToken, user, views, labels } from './store'

  function conditionsFailed (event) {
    if (event.detail.routeIsPrivate && event.detail.userIsLoggedIn === false) {
      replace('/login')
    }
  }

  get('/metadata')
    .then(({ data }) => {
      views.set(data.views)
      labels.set(data.labels)
      user.set(data.user)
      localStorage.setItem('user', JSON.stringify($user))

      if (data.user === null) {
        authToken.set(null)
        localStorage.removeItem('user')
        localStorage.removeItem('authToken')
        push('/login')
      }
    })
    .catch(console.error)

  const localUser = localStorage.getItem('user')
  const localToken = localStorage.getItem('authToken')
  authToken.set(localToken)
  if (localUser) {
    user.set(JSON.parse(localUser))
  }
</script>

<Router {routes} on:conditionsFailed={conditionsFailed} />
